Attribute VB_Name = "mMemory"
Option Explicit

'Created by SCINER: lenar2003@mail.ru
Public Type BITMAPINFOHEADER '40 bytes
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type
Public Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type
Public Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type
Public Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Public Const DIB_RGB_COLORS = 0
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long                            'lplpVoid changed to ByRef
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long

Public Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Public Type SAFEARRAY1D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 2) As SAFEARRAYBOUND
End Type

Public Type tSectType
  sA As SAFEARRAY1D
  DC As Long
  dib As Long
  Bmp As Long
  Obj As Long
  olddib As Long
  Pixels() As Byte
End Type

Public dSects(9999) As tSectType
Public eCount As Long

'       
Function Add(ByVal lWidth As Long, ByVal lHeight As Long, _
             Optional ByVal lBitsPerPixels As Long = 32) As Long

  Dim addr As Long
  Dim BmpInfo As BITMAPINFO
  Dim lChanels As Long

  lChanels = (lBitsPerPixels \ 8)

  '  BMP
  With BmpInfo.bmiHeader
    .biSize = 40
    .biWidth = lWidth
    .biHeight = -lHeight
    .biPlanes = 1
    .biBitCount = lBitsPerPixels
    .biSizeImage = lWidth * lHeight * lChanels
  End With

  With dSects(eCount)

'   
    If (.DC = 0) Then
      .DC = CreateCompatibleDC(0)
      If .DC = 0 Then
        Call MsgBox((Err.LastDllError), vbCritical, "LVImageManager.Add.CreateCompatibleDC")
        Add = -1
        Exit Function
      End If
    End If
    ' - 
    dSects(eCount).dib = CreateDIBSection(.DC, BmpInfo, DIB_RGB_COLORS, addr, 0, 0)
    If (addr = 0) Or (dSects(eCount).dib = 0) Then
      Call MsgBox((Err.LastDllError), vbCritical, "LVImageManager.Add.CreateDIBSection")
      Call DeleteDC(.DC)
      .DC = 0
      Add = -1
      Exit Function
    End If
    '     
    Call DeleteObject(SelectObject(.DC, dSects(eCount).dib))
    .sA.cbElements = 1
    .sA.cDims = 3
    .sA.Bounds(2).cElements = lChanels
    .sA.Bounds(1).cElements = lWidth
    .sA.Bounds(0).cElements = lHeight
    .sA.pvData = addr '   
    '    imgb,      DC
    '..      DC,  
    Call CopyMemory(ByVal VarPtrArray(.Pixels), VarPtr(dSects(eCount).sA), 4)
  End With

  Add = eCount

  eCount = eCount + 1

End Function

